# List Channels

> Source: https://truto.one/docs/api-reference/unified-instant-messaging-api/channels/list/

`GET /unified/instant-messaging/channels`

Resource: **Channels** · API: **Unified Instant Messaging API**

## Supported integrations

Google Chat, Microsoft 365, Microsoft Teams, Slack

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_key_by`** _(string)_
  By default the `result` attribute is an array of objects. This parameter allows you to specify a field in each `result` objects to use as key, which transforms the `result` array into an object with the array items keyed by the field. This is useful for when you want to use the result as a lookup table.
- **`truto_ignore_limit`** _(boolean)_
  Ignores the `limit` query parameter.
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.
- **`workspace`** _(object)_
  Workspace to which the channel belongs.
- **`type`** _(array<string>)_
  Type of the channel. Defaults to 'all'.
  Allowed: `channel`, `dm`, `group_dm`, `private_channel`
- **`user`** _(object)_
  The user whose messages are to be retrieved.
- **`exclude_archived`** _(boolean)_
  Set to true to exclude archived channels from the list.

## Response body

- **`result`** _(array<object>)_
  List of Channels
  - **`id`** _(string, required)_
    Unique identifier for the channel.
  - **`name`** _(string)_
    Name of the channel.
  - **`description`** _(string)_
    Description of the channel.
  - **`organization`** _(object)_
    Organization to which the channel belongs.
    - **`id`** _(string)_
      Unique identifier for the organization.
    - **`name`** _(string)_
      Name of the organization.
  - **`workspace`** _(object)_
    Workspace to which the channel belongs.
    - **`id`** _(string)_
      Unique identifier for the workspace.
    - **`name`** _(string)_
      Name of the workspace.
  - **`group`** _(object)_
    Group to which the channel belongs.
    - **`id`** _(string)_
      Unique identifier for the group.
    - **`name`** _(string)_
      Name of the group.
  - **`type`** _(string)_
    Type of the channel.
    Allowed: `channel`, `private_channel`, `dm`, `group_dm`
  - **`status`** _(string)_
    Status of the channel.
    Allowed: `active`, `archived`
  - **`is_member`** _(boolean)_
    Is the current authed user or application is a member of the channel. This might not directly mean that the user or application can post messages on the channel.
  - **`created_by`** _(object)_
    - **`id`** _(string)_
      Unique identifier for the member.
  - **`created_at`** _(string)_
    Date and time when the channel was created.
  - **`updated_at`** _(string)_
    Date and time when the channel was last updated.
  - **`remote_data`** _(object)_
    Raw data returned from the remote API call.
- **`next_cursor`** _(string)_
  The cursor to use for the next page of results. Pass this value as `next_cursor` in the query parameter in the next request to get the next page of results.

## Code examples

### curl

```bash
curl -X GET 'https://api.truto.one/unified/instant-messaging/channels?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const response = await fetch(`https://api.truto.one/unified/instant-messaging/channels?integrated_account_id=${integratedAccountId}`, {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/instant-messaging/channels"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}

response = requests.get(url, headers=headers, params=params)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.list(
  'instant-messaging',
  'channels',
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    async for item in truto_api.unified_api.list(
        "instant-messaging",
        "channels",
        {"integrated_account_id": "<integrated_account_id>"}
    ):
        print(item)

asyncio.run(main())
```
